<?php
# -- BEGIN LICENSE BLOCK ----------------------------------
#
# This file is part of Dotclear 2.
#
# Copyright (c) 2003-2008 Olivier Meunier and contributors
# Licensed under the GPL version 2.0 license.
# See LICENSE file or
# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
#
# -- END LICENSE BLOCK ------------------------------------

$core->addBehavior('adminBlogPreferencesForm',array('googleWaveBehaviors','adminBlogPreferencesForm'));
$core->addBehavior('adminBeforeBlogSettingsUpdate',array('googleWaveBehaviors','adminBeforeBlogSettingsUpdate'));

$core->addBehavior('adminPostHeaders',array('googleWaveBehaviors','adminPostHeaders'));
$core->addBehavior('adminBlogPreferencesHeaders',array('googleWaveBehaviors','adminBlogPreferencesHeaders'));
/* Don't know what the following is for, hence skipping these declarations
$core->addBehavior('adminPageHeaders',array('externalMediaBehaviors','jsLoad'));
$core->addBehavior('adminRelatedHeaders',array('externalMediaBehaviors','jsLoad'));
$core->addBehavior('adminDashboardHeaders',array('externalMediaBehaviors','jsLoad'));
 */

class googleWaveBehaviors
{
	public static function adminBlogPreferencesForm(&$core,&$settings)
	{
		echo
		'<fieldset><legend>GoogleWave</legend>'.
		'<p><label class="classic">'.
		form::checkbox('googlewave_enabled','1',$settings->googlewave_enabled).
		__('Enable GoogleWave embedding').'</label></p>';

		echo '<div class="two-cols">'."\n";
		/* Box dimension & alignment */
		$align = array(
			__('None') => 'none',
			__('Left') => 'left',
			__('Right') => 'right',
			__('Center') => 'center'
		);
		$previous_align_key = 'none';
		foreach( $align as $k => $v ){
			if ($v == $settings->alignment) { $previous_align_key = $v; }
		}
		echo '<div class="col">'."\n".
		'<h4>'.__('Default box dimension & Alignment').'</h4>'.
		'<p class="field"><label>'.__('Media alignment').
		form::combo('alignment', $align,$previous_align_key).
		'</label></p>'.
		'<p class="field"><label>'.__('Width').
		form::field('width',14,14,$settings->width).
		'</label></p>'.
		'<p class="field"><label>'.__('Height').
		form::field('height',14,14,$settings->height).
		'</label></p>'.
		"\n".'</div>'."\n";
		/* Appearance settings */
		echo '<div class="col">'."\n".
		'<h4>'.__('Default appearance setting').'</h4>'.
		'<p class="field"><label>'.__('Background color').
		form::field('background',14,14,$settings->background,'colorpicker').
		'</label></p>'.
		'<p class="field"><label>'.__('Text color').
		form::field('foreground',14,14,$settings->foreground,'colorpicker').
		'</label></p>'.
		'<p class="field"><label>'.__('Font').
		form::field('font',14,14,$settings->font).
		'</label></p>'.
		'<p class="field"><label>'.__('Font size').
		form::field('font_size',14,14,$settings->font_size).
		'</label></p>'.
		"\n".'</div>'."\n".
		'</div> <!-- end two-cols -->'."\n";


		/* Appearance settings */
		echo '<h4>'.__('Default server settings').'</h4>'."\n".
			'<div class="two-cols">'."\n".
			'<p>You can either use '.
			'the sandbox setting with "server" = <em>http://wave.google.com/a/wavesandbox.com/</em> and "fName" = <em>wavesandbox.com!w+</em>, '.
			'the preview configuration with "server" = <em>http://wave.google.com/wave/</em> and "fName" = <em>googlewave.com!w+</em> '.
			'or enter your own personal values. The <em>waveID</em> will be concatenated after the "fName" parameter.</p>'.
			'<div class="col">'."\n".
			'<p><label class="classic">'.__('Wave Server').' '.
			form::field('server',50,180,$settings->server).
			'</label></p>'.
			"\n".'</div>'."\n".
			'<div class="col">'."\n".
			'<p><label class="classic">'.__('Wave formatted name').
			form::field('fName',20,50,$settings->fName).
			'<em>waveID</em></label></p>'.
			"\n".'</div>'."\n".
			'</div> <!-- end two-cols -->'."\n";

		echo '</fieldset>';
	}
	
	public static function adminBeforeBlogSettingsUpdate(&$settings)
	{
		$settings->setNameSpace('googlewave');

		$settings->put('googlewave_enabled',!empty($_POST['googlewave_enabled']),'boolean');
		/* Box */
		$settings->put('width',$_POST['width'],'string');
		$settings->put('height',$_POST['height'],'string');
		$settings->put('alignment',$_POST['alignment'],'string');
		/* Appearance */
		$settings->put('background',$_POST['background'],'string');
		$settings->put('foreground',$_POST['foreground'],'string');
		$settings->put('font',$_POST['font'],'string');
		$settings->put('font_size',$_POST['font_size'],'string');
		/* Server */
		$settings->put('server',$_POST['server'],'string');
		$settings->put('fName',$_POST['fName'],'string');

		$settings->setNameSpace('system');
	}

	public static function adminPostHeaders()
	{
		return
		'<script type="text/javascript" src="index.php?pf=googleWave/js/post.js"></script>'."\n";
		'<script type="text/javascript">'."\n".
		"//<![CDATA[\n".
		dcPage::jsVar('jsToolBar.prototype.elements.gwave.title',__('Add a Google Wave')).
		"\n//]]>\n".
		"</script>\n";
	}

	public static function adminBlogPreferencesHeaders()
	{
		return dcPage::jsColorPicker();
	}
}
?>
